
var styleController = JSB.defineClass('styleController : UIViewController', {
  viewDidLoad: function() {
    let config  =  NSUserDefaults.standardUserDefaults().objectForKey("MNAutoStyle")
    self.appInstance = Application.sharedInstance();
    self.homeImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/home.png`), 2)
    self.bothModeImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/bothMode.png`), 2)
    self.goforwardImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/goforward.png`), 2)
    self.screenImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/screen.png`), 2)
    self.snipasteImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/snipaste.png`), 2)
    self.closeImage = UIImage.imageWithDataScale(NSData.dataWithContentsOfFile(self.mainPath + `/stop.png`), 2)
    self.custom = false;
    self.customMode = "None"
    self.dynamic = true;
    self.miniMode = false;
    self.isLoading = false;
    self.lastFrame = self.view.frame;
    self.currentFrame = self.view.frame
    self.mode = 0
    self.moveDate = Date.now()
    self.textPattern      = (config && config.text)     ?  config.text      :[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]
    self.imagePattern     = (config && config.image)    ?  config.image     :[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]
    self.copyPattern      = (config && config.copy)     ?  config.copy       :[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]
    self.searchPattern    = (config && config.search)   ?  config.search    :[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]
    self.bigbangPattern   = (config && config.bigbang)  ?  config.bigbang   :[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]
    self.snipastePattern  = (config && config.snipaste) ?  config.snipaste  :[0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0]

// 0都没有
// 1都有
// 2image
// 3text
    self.view.layer.shadowOffset = {width: 0, height: 0};
    self.view.layer.shadowRadius = 15;
    self.view.layer.shadowOpacity = 0.5;
    self.view.layer.shadowColor = UIColor.colorWithWhiteAlpha(0.5, 1);
    self.view.layer.opacity = 1.0
    self.view.layer.cornerRadius = 11
    self.view.backgroundColor = UIColor.whiteColor().colorWithAlphaComponent(0.8)
    self.highlightColor = UIColor.blendedColor(
      UIColor.colorWithHexString("#2c4d81").colorWithAlphaComponent(0.8),
      Application.sharedInstance().defaultTextColor,
      0.8
    );

// >>> opacity button >>>
    // self.webAppButton.titleLabel.font = UIFont.systemFontOfSize(12);
    // <<< opacity button <<<

    // >>> max button >>>
    self.maxButton = UIButton.buttonWithType(0);
    // self.setButtonLayout(self.maxButton,"maxButtonTapped:")
    self.maxButton.setTitleForState('➕', 0);
    self.maxButton.titleLabel.font = UIFont.systemFontOfSize(10);
    // <<< max button <<<


    // <<< search button <<<
    // >>> move button >>>
    self.moveButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.moveButton)
    // <<< move button <<<
    // >>> close button >>>
    self.closeButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.closeButton,"closeButtonTapped:")
    // self.closeButton.setTitleForState('✖️', 0);
    self.closeButton.setImageForState(self.closeImage,0)

    self.closeButton.backgroundColor = UIColor.whiteColor().colorWithAlphaComponent(0)
    self.closeButton.titleLabel.font = UIFont.systemFontOfSize(14);
    // <<< close button <<<
    // >>> goForward button >>>
    self.textModeButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.textModeButton,"textButtonTapped:")
    self.textModeButton.backgroundColor = UIColor.whiteColor().colorWithAlphaComponent(0)
    self.textModeButton.layer.opacity = 0.5
    self.textModeButton.setTitleForState("Text",0)
    // self.textModeButton.setImageForState(self.goforwardImage,0)
    // <<< goForward button <<<
      // >>> bothMode button >>>
    self.bothModeButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.bothModeButton,"bothButtonTapped:")
    self.bothModeButton.backgroundColor = UIColor.colorWithHexString("#5982c4");
    self.bothModeButton.layer.opacity = 1.0
    self.bothModeButton.setTitleForState("Both",0)

    // self.bothModeButton.setImageForState(self.bothModeImage,0)
    // <<< bothMode button <<<
    // >>> search button >>>
    self.imageModeButton = UIButton.buttonWithType(0);
    self.setButtonLayout(self.imageModeButton,"imageButtonTapped:")
    self.imageModeButton.backgroundColor = UIColor.whiteColor().colorWithAlphaComponent(0)
    self.imageModeButton.layer.opacity = 0.5
    // self.imageModeButton.setImageForState(self.snipasteImage,0)
    self.imageModeButton.setTitleForState("Image",0)



    // self.imageModeButton.setTitleForState('🔍', 0);
    // self.tabButton      = UIButton.buttonWithType(0);
    self.color = ["#ffffb4","#ccfdc4","#b4d1fb","#f3aebe","#ffff54","#75fb4c","#55bbf9","#ea3323","#ef8733","#377e47","#173dac","#be3223","#ffffff","#dadada","#b4b4b4","#bd9fdc"]
    for (let index = 0; index < 16; index++) {
      self["ColorButton"+index]   = UIButton.buttonWithType(0);
      self["ColorButton"+index].index = index
      self.setColorButtonLayout(self["ColorButton"+index],"changeColorPattern:",self.color[index])
      self["ColorButton"+index].setTitleForState(self.imagePattern[index]===self.textPattern[index]?` ${self.imagePattern[index]} `:"-1",0) 
    }

        // >>> screen button >>>
    self.screenButton = UIButton.buttonWithType(0);
    // self.setButtonLayout(self.screenButton,"changeScreen:")
    // self.screenButton.setImageForState(self.screenImage,0)
    // <<< screen button <<<
    self.moveGesture0 = new UIPanGestureRecognizer(self,"onMoveGesture:")
    self.textModeButton.addGestureRecognizer(self.moveGesture0)
    self.moveGesture0.view.hidden = false
    self.moveGesture0.addTargetAction(self,"onMoveGesture:")
    self.moveGesture1 = new UIPanGestureRecognizer(self,"onMoveGesture:")
    self.imageModeButton.addGestureRecognizer(self.moveGesture1)
    self.moveGesture1.view.hidden = false
    self.moveGesture1.addTargetAction(self,"onMoveGesture:")
    self.moveGesture2 = new UIPanGestureRecognizer(self,"onMoveGesture:")
    self.bothModeButton.addGestureRecognizer(self.moveGesture2)
    self.moveGesture2.view.hidden = false
    self.moveGesture2.addTargetAction(self,"onMoveGesture:")
    self.moveGesture3 = new UIPanGestureRecognizer(self,"onMoveGesture:")
    self.closeButton.addGestureRecognizer(self.moveGesture3)
    self.moveGesture3.view.hidden = false
    self.moveGesture3.addTargetAction(self,"onMoveGesture:")
    self.moveGesture = new UIPanGestureRecognizer(self,"onMoveGesture:")
    self.moveButton.addGestureRecognizer(self.moveGesture)
    self.moveGesture.view.hidden = false
    self.moveGesture.addTargetAction(self,"onMoveGesture:")
    // self.moveButton.addGestureRecognizer(self.moveGesture)
    // self.imageModeButton.addGestureRecognizer(self.moveGesture)
    // self.bothModeButton.addGestureRecognizer(self.moveGesture)




    // self.resizeGesture = new UIPanGestureRecognizer(self,"onResizeGesture:")
    // self.screenButton.addGestureRecognizer(self.resizeGesture)
    // self.resizeGesture.view.hidden = false
    // self.resizeGesture.addTargetAction(self,"onResizeGesture:")
  },
  viewWillAppear: function(animated) {
  },
  viewWillDisappear: function(animated) {
  },
viewWillLayoutSubviews: function() {
    if (self.miniMode) {
      return
    }

    var viewFrame = self.view.bounds;
    var xLeft     = viewFrame.x
    var xRight    = xLeft + viewFrame.width
    var yTop      = viewFrame.y
    var yBottom   = yTop + viewFrame.height
    self.closeButton.frame = {x: xLeft+200,y: 10,width: 30,height: 30};
    self.maxButton.frame   = {x: xRight-43,y: yTop,width: 18,height: 18};
    self.moveButton.frame = {x: xLeft+10 ,y: 10,width: 230,height: 30};
    // self.screenButton.frame = {  x: xRight-40,  y: yBottom-40,  width: 30,  height: 30,};
    self.imageModeButton.frame = {  x: xLeft+128,  y: 10,  width: 55,  height: 30,}
    self.bothModeButton.frame = {  x: xLeft+10,  y: 10,  width: 50,  height: 30,};
    self.textModeButton.frame = {  x: xLeft+67,  y: 10,  width: 55,  height: 30,};
    let initX = 10
    let initY = 50
    for (let index = 0; index < 16; index++) {
      if (xLeft+initX+50 > viewFrame.width) {
        initX = 10
        initY = initY+60
      }
      self["ColorButton"+index].frame = {  x: xLeft+initX,  y: initY,  width: 50,  height: 50,};
      initX = initX+60
    }

  },
  scrollViewDidScroll: function() {
  },
  changeColorPattern: function (sender) {
    //  Application.sharedInstance().showHUD("index:"+sender.index, self.view.window, 2);

    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var menuController = MenuController.new();
    let imagePattern    = self.imagePattern[sender.index]
    let textPattern     = self.textPattern[sender.index]
    let searchPattern  = self.searchPattern[sender.index]
    let bigbangPattern  = self.bigbangPattern[sender.index]
    let snipastePattern = self.snipastePattern[sender.index]
    let copyPattern = self.copyPattern[sender.index]

    let checkList
    switch (self.mode) {
      case 0:
        checkList = ((imagePattern===textPattern)?[imagePattern===0,imagePattern===1,imagePattern===2]:[false,false,false]).concat(copyPattern===1,searchPattern===1,bigbangPattern===1,snipastePattern===1)
        break;
      case 1:
        checkList = [textPattern===0,textPattern===1,textPattern===2,copyPattern===1||copyPattern===2,searchPattern===1||searchPattern===2,bigbangPattern===1||bigbangPattern===2,snipastePattern===1||snipastePattern===2]
        break
      case 2:
        checkList = [imagePattern===0,imagePattern===1,imagePattern===2,copyPattern===1||copyPattern===3,searchPattern===1||searchPattern===3,bigbangPattern===1||bigbangPattern===3,snipastePattern===1||snipastePattern===3]
        break
      default:
        break;
    }
    menuController.commandTable = [
      {title:'0️⃣ Both',object:self,selector:'setBothPattern:',param:sender,checked:checkList[0]},
      {title:'1️⃣ Fill',object:self,selector:'setFillPattern:',param:sender,checked:checkList[1]},
      {title:'2️⃣ Border',object:self,selector:'setBorderPattern:',param:sender,checked:checkList[2]},
      {title:'Auto copy',object:self,selector:'setAutoCopy:',param:sender,checked:checkList[3]},
      {title:'Auto search',object:self,selector:'setAutoSearch:',param:sender,checked:checkList[4]},
      {title:'Auto bigbang',object:self,selector:'setAutoBigbang:',param:sender,checked:checkList[5]},
      {title:'Auto snipaste',object:self,selector:'setAutoSnipaste:',param:sender,checked:checkList[6]},

    ];
    menuController.rowHeight = 35;
    menuController.preferredContentSize = {
      width: 200,
      height: menuController.rowHeight * menuController.commandTable.length
    };
    var studyController = Application.sharedInstance().studyController(self.view.window);
    self.view.popoverController = new UIPopoverController(menuController);
    var r = sender.convertRectToView(sender.bounds,studyController.view);
    self.view.popoverController.presentPopoverFromRect(r, studyController.view, 1 << 1, true);
  },
  setBothPattern: function (sender) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    sender.setTitleForState(" 0 ",0)
    switch (self.mode) {
      case 0:
        self.textPattern[sender.index] = 0
        self.imagePattern[sender.index] = 0
        break;
      case 1:
        self.textPattern[sender.index] = 0
        break;
      case 2:
        self.imagePattern[sender.index] = 0
        break;
      default:
        break;
    }
    NSUserDefaults.standardUserDefaults().setObjectForKey({image:self.imagePattern,text:self.textPattern,copy:self.copyPattern,search:self.searchPattern,bigbang:self.bigbangPattern,snipaste:self.snipastePattern},"MNAutoStyle")
  },
  setFillPattern: function (sender) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}

    sender.setTitleForState(" 1 ",0)
    switch (self.mode) {
      case 0:
        self.textPattern[sender.index] = 1
        self.imagePattern[sender.index] = 1
        break;
      case 1:
        self.textPattern[sender.index] = 1
        break;
      case 2:
        self.imagePattern[sender.index] = 1
        break;
      default:
        break;
    }
    NSUserDefaults.standardUserDefaults().setObjectForKey({image:self.imagePattern,text:self.textPattern,copy:self.copyPattern,search:self.searchPattern,bigbang:self.bigbangPattern,snipaste:self.snipastePattern},"MNAutoStyle")
  },
  setBorderPattern: function (sender) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}

    sender.setTitleForState(" 2 ",0)
    switch (self.mode) {
      case 0:
        self.textPattern[sender.index] = 2
        self.imagePattern[sender.index] = 2
        break;
      case 1:
        self.textPattern[sender.index] = 2
        break;
      case 2:
        self.imagePattern[sender.index] = 2
        break;
      default:
        break;
    }
    NSUserDefaults.standardUserDefaults().setObjectForKey({image:self.imagePattern,text:self.textPattern,copy:self.copyPattern,search:self.searchPattern,bigbang:self.bigbangPattern,snipaste:self.snipastePattern},"MNAutoStyle")
  },
  setAutoCopy: function (sender) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    // self.appInstance.showHUD("mode:"+self.mode,self.view.window,2)

    switch (self.mode) {
      case 0:
        self.copyPattern[sender.index] = (self.copyPattern[sender.index] === 1)?0:1
        break;
      case 1:
        switch (self.copyPattern[sender.index]) {
          case 0:
            self.copyPattern[sender.index] = 2
            break;
          case 1:
            self.copyPattern[sender.index] = 3
            break;
          case 2:
            self.copyPattern[sender.index] = 0
            break;
          case 3:
            self.copyPattern[sender.index] = 1
            break;
          default:
            self.copyPattern[sender.index] = 0
            break;
        }
        break;
      case 2:
        switch (self.copyPattern[sender.index]) {
          case 0:
            self.copyPattern[sender.index] = 3
            break;
          case 1:
            self.copyPattern[sender.index] = 2
            break;
          case 2:
            self.copyPattern[sender.index] = 1
            break;
          case 3:
            self.copyPattern[sender.index] = 0
            break;
          default:
            self.copyPattern[sender.index] = 0
            break;
        }
        break;
      default:
        break;
    }
    // self.appInstance.showHUD("pattern:"+self.copyPattern[sender.index],self.view.window,2)

    NSUserDefaults.standardUserDefaults().setObjectForKey({image:self.imagePattern,text:self.textPattern,copy:self.copyPattern,search:self.searchPattern,bigbang:self.bigbangPattern,snipaste:self.snipastePattern},"MNAutoStyle")
  },
  setAutoSearch: function (sender) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    // self.appInstance.showHUD("mode:"+self.mode,self.view.window,2)

    switch (self.mode) {
      case 0:
        self.searchPattern[sender.index] = (self.searchPattern[sender.index] === 1)?0:1
        break;
      case 1:
        switch (self.searchPattern[sender.index]) {
          case 0:
            self.searchPattern[sender.index] = 2
            break;
          case 1:
            self.searchPattern[sender.index] = 3
            break;
          case 2:
            self.searchPattern[sender.index] = 0
            break;
          case 3:
            self.searchPattern[sender.index] = 1
            break;
          default:
            self.searchPattern[sender.index] = 0
            break;
        }
        break;
      case 2:
        switch (self.searchPattern[sender.index]) {
          case 0:
            self.searchPattern[sender.index] = 3
            break;
          case 1:
            self.searchPattern[sender.index] = 2
            break;
          case 2:
            self.searchPattern[sender.index] = 1
            break;
          case 3:
            self.searchPattern[sender.index] = 0
            break;
          default:
            self.searchPattern[sender.index] = 0
            break;
        }
        break;
      default:
        break;
    }
    // self.appInstance.showHUD("pattern:"+self.searchPattern[sender.index],self.view.window,2)

    NSUserDefaults.standardUserDefaults().setObjectForKey({image:self.imagePattern,text:self.textPattern,copy:self.copyPattern,search:self.searchPattern,bigbang:self.bigbangPattern,snipaste:self.snipastePattern},"MNAutoStyle")
  },
  setAutoBigbang: function (sender) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    switch (self.mode) {
      case 0:
        self.bigbangPattern[sender.index] = (self.bigbangPattern[sender.index] === 1)?0:1
        break;
      case 1:
        switch (self.bigbangPattern[sender.index]) {
          case 0:
            self.bigbangPattern[sender.index] = 2
            break;
          case 1:
            self.bigbangPattern[sender.index] = 3
            break;
          case 2:
            self.bigbangPattern[sender.index] = 0
            break;
          case 3:
            self.bigbangPattern[sender.index] = 1
            break;
          default:
            self.bigbangPattern[sender.index] = 0
            break;
        }
        break;
      case 2:
        switch (self.bigbangPattern[sender.index]) {
          case 0:
            self.bigbangPattern[sender.index] = 3
            break;
          case 1:
            self.bigbangPattern[sender.index] = 2
            break;
          case 2:
            self.bigbangPattern[sender.index] = 1
            break;
          case 3:
            self.bigbangPattern[sender.index] = 0
            break;
          default:
            self.bigbangPattern[sender.index] = 0
            break;
        }
        break;
      default:
        break;
    }
    NSUserDefaults.standardUserDefaults().setObjectForKey({image:self.imagePattern,text:self.textPattern,copy:self.copyPattern,search:self.searchPattern,bigbang:self.bigbangPattern,snipaste:self.snipastePattern},"MNAutoStyle")
  },
  setAutoSnipaste: function (sender) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    switch (self.mode) {
      case 0:
        self.snipastePattern[sender.index] = (self.snipastePattern[sender.index] === 1)?0:1
        break;
      case 1:
        switch (self.snipastePattern[sender.index]) {
          case 0:
            self.snipastePattern[sender.index] = 2
            break;
          case 1:
            self.snipastePattern[sender.index] = 3
            break;
          case 2:
            self.snipastePattern[sender.index] = 0
            break;
          case 3:
            self.snipastePattern[sender.index] = 1
            break;
          default:
            self.snipastePattern[sender.index] = 0
            break;
        }
        break;
      case 2:
        switch (self.snipastePattern[sender.index]) {
          case 0:
            self.snipastePattern[sender.index] = 3
            break;
          case 1:
            self.snipastePattern[sender.index] = 2
            break;
          case 2:
            self.snipastePattern[sender.index] = 1
            break;
          case 3:
            self.snipastePattern[sender.index] = 0
            break;
          default:
            self.snipastePattern[sender.index] = 0
            break;
        }
        break;
      default:
        break;
    }
    NSUserDefaults.standardUserDefaults().setObjectForKey({image:self.imagePattern,text:self.textPattern,copy:self.copyPattern,search:self.searchPattern,bigbang:self.bigbangPattern,snipaste:self.snipastePattern},"MNAutoStyle")
  },
  changeOpacity: function(sender) {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    var menuController = MenuController.new();
    menuController.commandTable = [
      {title:'100%',object:self,selector:'changeOpacityTo:',param:1.0},
      {title:'90%',object:self,selector:'changeOpacityTo:',param:0.9},
      {title:'80%',object:self,selector:'changeOpacityTo:',param:0.8},
      {title:'70%',object:self,selector:'changeOpacityTo:',param:0.7},
      {title:'60%',object:self,selector:'changeOpacityTo:',param:0.6},
      {title:'50%',object:self,selector:'changeOpacityTo:',param:0.5}
    ];
    menuController.rowHeight = 35;
    menuController.preferredContentSize = {
      width: 100,
      height: menuController.rowHeight * menuController.commandTable.length
    };
    var studyController = Application.sharedInstance().studyController(self.view.window);
    self.view.popoverController = new UIPopoverController(menuController);
    var r = sender.convertRectToView(sender.bounds,studyController.view);
    self.view.popoverController.presentPopoverFromRect(r, studyController.view, 1 << 1, true);
  },
  changeOpacityTo:function (opacity) {
    self.view.layer.opacity = opacity
    // self.webAppButton.setTitleForState(`${opacity*100}%`, 0);
  },
  imageButtonTapped: function() {
    self.mode = 2
    self.imageModeButton.backgroundColor = UIColor.colorWithHexString("#5982c4");
    self.imageModeButton.layer.opacity = 1.0
    self.textModeButton.backgroundColor = UIColor.whiteColor().colorWithAlphaComponent(0)
    self.textModeButton.layer.opacity = 0.5
    self.bothModeButton.backgroundColor = UIColor.whiteColor().colorWithAlphaComponent(0)
    self.bothModeButton.layer.opacity = 0.5
    self.ColorButton0.setTitleForState(` ${self.imagePattern[0]} `,0) 
    self.ColorButton1.setTitleForState(` ${self.imagePattern[1]} `,0) 
    self.ColorButton2.setTitleForState(` ${self.imagePattern[2]} `,0) 
    self.ColorButton3.setTitleForState(` ${self.imagePattern[3]} `,0) 
    self.ColorButton4.setTitleForState(` ${self.imagePattern[4]} `,0) 
    self.ColorButton5.setTitleForState(` ${self.imagePattern[5]} `,0) 
    self.ColorButton6.setTitleForState(` ${self.imagePattern[6]} `,0) 
    self.ColorButton7.setTitleForState(` ${self.imagePattern[7]} `,0) 
    self.ColorButton8.setTitleForState(` ${self.imagePattern[8]} `,0) 
    self.ColorButton9.setTitleForState(` ${self.imagePattern[9]} `,0) 
    self.ColorButton10.setTitleForState(` ${self.imagePattern[10]} `,0)
    self.ColorButton11.setTitleForState(` ${self.imagePattern[11]} `,0)
    self.ColorButton12.setTitleForState(` ${self.imagePattern[12]} `,0)
    self.ColorButton13.setTitleForState(` ${self.imagePattern[13]} `,0)
    self.ColorButton14.setTitleForState(` ${self.imagePattern[14]} `,0)
    self.ColorButton15.setTitleForState(` ${self.imagePattern[15]} `,0)
  },
  bothButtonTapped: function() {
    self.mode = 0
    self.bothModeButton.backgroundColor = UIColor.colorWithHexString("#5982c4");
    self.bothModeButton.layer.opacity = 1.0
    self.textModeButton.backgroundColor = UIColor.whiteColor().colorWithAlphaComponent(0)
    self.textModeButton.layer.opacity = 0.5
    self.imageModeButton.backgroundColor = UIColor.whiteColor().colorWithAlphaComponent(0)
    self.imageModeButton.layer.opacity = 0.5
    self.ColorButton0.setTitleForState(self.imagePattern[0]===self.textPattern[0]?` ${self.imagePattern[0]} `:"-1",0) 
    self.ColorButton1.setTitleForState(self.imagePattern[1]===self.textPattern[1]?` ${self.imagePattern[1]} `:"-1",0) 
    self.ColorButton2.setTitleForState(self.imagePattern[2]===self.textPattern[2]?` ${self.imagePattern[2]} `:"-1",0) 
    self.ColorButton3.setTitleForState(self.imagePattern[3]===self.textPattern[3]?` ${self.imagePattern[3]} `:"-1",0) 
    self.ColorButton4.setTitleForState(self.imagePattern[4]===self.textPattern[4]?` ${self.imagePattern[4]} `:"-1",0) 
    self.ColorButton5.setTitleForState(self.imagePattern[5]===self.textPattern[5]?` ${self.imagePattern[5]} `:"-1",0) 
    self.ColorButton6.setTitleForState(self.imagePattern[6]===self.textPattern[6]?` ${self.imagePattern[6]} `:"-1",0) 
    self.ColorButton7.setTitleForState(self.imagePattern[7]===self.textPattern[7]?` ${self.imagePattern[7]} `:"-1",0) 
    self.ColorButton8.setTitleForState(self.imagePattern[8]===self.textPattern[8]?` ${self.imagePattern[8]} `:"-1",0) 
    self.ColorButton9.setTitleForState(self.imagePattern[9]===self.textPattern[9]?` ${self.imagePattern[9]} `:"-1",0) 
    self.ColorButton10.setTitleForState(self.imagePattern[10]===self.textPattern[10]?` ${self.imagePattern[10]} `:"-1",0)
    self.ColorButton11.setTitleForState(self.imagePattern[11]===self.textPattern[11]?` ${self.imagePattern[11]} `:"-1",0)
    self.ColorButton12.setTitleForState(self.imagePattern[12]===self.textPattern[12]?` ${self.imagePattern[12]} `:"-1",0)
    self.ColorButton13.setTitleForState(self.imagePattern[13]===self.textPattern[13]?` ${self.imagePattern[13]} `:"-1",0)
    self.ColorButton14.setTitleForState(self.imagePattern[14]===self.textPattern[14]?` ${self.imagePattern[14]} `:"-1",0)
    self.ColorButton15.setTitleForState(self.imagePattern[15]===self.textPattern[15]?` ${self.imagePattern[15]} `:"-1",0)
    
  },
  textButtonTapped: function() {
    self.mode = 1
    self.textModeButton.backgroundColor = UIColor.colorWithHexString("#5982c4");
    self.textModeButton.layer.opacity = 1.0
    self.imageModeButton.backgroundColor = UIColor.whiteColor().colorWithAlphaComponent(0)
    self.imageModeButton.layer.opacity = 0.5
    self.bothModeButton.backgroundColor = UIColor.whiteColor().colorWithAlphaComponent(0)
    self.bothModeButton.layer.opacity = 0.5

    self.ColorButton0.setTitleForState(` ${self.textPattern[0]} `,0) 
    self.ColorButton1.setTitleForState(` ${self.textPattern[1]} `,0) 
    self.ColorButton2.setTitleForState(` ${self.textPattern[2]} `,0) 
    self.ColorButton3.setTitleForState(` ${self.textPattern[3]} `,0) 
    self.ColorButton4.setTitleForState(` ${self.textPattern[4]} `,0) 
    self.ColorButton5.setTitleForState(` ${self.textPattern[5]} `,0) 
    self.ColorButton6.setTitleForState(` ${self.textPattern[6]} `,0) 
    self.ColorButton7.setTitleForState(` ${self.textPattern[7]} `,0) 
    self.ColorButton8.setTitleForState(` ${self.textPattern[8]} `,0) 
    self.ColorButton9.setTitleForState(` ${self.textPattern[9]} `,0) 
    self.ColorButton10.setTitleForState(` ${self.textPattern[10]} `,0)
    self.ColorButton11.setTitleForState(` ${self.textPattern[11]} `,0)
    self.ColorButton12.setTitleForState(` ${self.textPattern[12]} `,0)
    self.ColorButton13.setTitleForState(` ${self.textPattern[13]} `,0)
    self.ColorButton14.setTitleForState(` ${self.textPattern[14]} `,0)
    self.ColorButton15.setTitleForState(` ${self.textPattern[15]} `,0)
  },
  closeButtonTapped: function() {
    self.view.hidden = true;
    },
  leftButtonTapped: function() {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}

    // self.view.popoverController.dismissPopoverAnimated(true);
    self.lastFrame = self.view.frame
    let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
    let height = studyFrame.height;
    let splitLine = getSplitLine()
    // Application.sharedInstance().showHUD(splitLine,self.view.window,2)
    self.view.frame = {x:40,y:50,width:splitLine-40,height:height-50}
    self.custom = true;
    self.customMode = "left"
    self.dynamic = false;
    self.moveButton.hidden = false
    self.maxButton.hidden = false
    self.closeButton.hidden = false
  },
  left13ButtonTapped: function() {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    self.customMode = "left13"
    self.dynamic = false;
    self.lastFrame = self.view.frame

    // self.view.popoverController.dismissPopoverAnimated(true);
    let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
    let height = studyFrame.height;
    // Application.sharedInstance().showHUD(splitLine,self.view.window,2)
    self.view.frame = {x:40,y:60,width:studyFrame.width/3.+40,height:height-60}
    self.custom = true;
    self.moveButton.hidden = false
    self.maxButton.hidden = false
    self.closeButton.hidden = false
  },
  rightButtonTapped: function() {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    self.customMode = "right"
    self.dynamic = false;
    self.lastFrame = self.view.frame
    // self.view.popoverController.dismissPopoverAnimated(true);
    let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
    let height = studyFrame.height;
    let splitLine = getSplitLine()
    self.view.frame = {x:splitLine,y:50,width:studyFrame.width-splitLine-40,height:height-50}
    self.custom = true;
    self.moveButton.hidden = false
    self.maxButton.hidden = false
    self.closeButton.hidden = false
  },
  right13ButtonTapped: function() {
    if (self.view.popoverController) {self.view.popoverController.dismissPopoverAnimated(true);}
    self.custom = true;
    self.customMode = "right13"
    self.dynamic = false;
    self.lastFrame = self.view.frame
    // self.view.popoverController.dismissPopoverAnimated(true);
    let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
    let height = studyFrame.height;
    let splitLine = getSplitLine()
    self.view.frame = {x:splitLine,y:50,width:studyFrame.width-splitLine-40,height:height-50}
    self.moveButton.hidden = false
    self.maxButton.hidden = false
    self.closeButton.hidden = false
  },
  maxButtonTapped: function() {
    if (self.customMode === "full") {
      self.customMode = "none"
      self.custom = false;
      self.view.frame = self.lastFrame
      return
    }
    const frame = Application.sharedInstance().studyController(this.window).view.bounds
    self.lastFrame = self.view.frame
    self.view.frame = {x:40,y:50,width:frame.width-80,height:frame.height-70}
    self.customMode = "full"
    self.custom = true;
    self.dynamic = false;
  },
  onMoveGesture:function (gesture) {

self.dynamic = false;
    let locationToMN = gesture.locationInView(self.appInstance.studyController(self.view.window).view)
    if ( (Date.now() - self.moveDate) > 100) {
      let translation = gesture.translationInView(self.appInstance.studyController(self.view.window).view)
      let locationToBrowser = gesture.locationInView(self.view)
      let locationToButton = gesture.locationInView(gesture.view)
      let buttonFrame = self.moveButton.frame
      let newY = locationToButton.y-translation.y 
      let newX = locationToButton.x-translation.x
      if (gesture.state !== 3 && (newY<buttonFrame.height && newY>0 && newX<buttonFrame.width && newX>0 && Math.abs(translation.y)<20 && Math.abs(translation.x)<20)) {
        self.locationToBrowser = {x:locationToBrowser.x-translation.x,y:locationToBrowser.y-translation.y}
      }
    }
    self.moveDate = Date.now()
    let location = {x:locationToMN.x - self.locationToBrowser.x,y:locationToMN.y -self.locationToBrowser.y}
    let frame = self.view.frame
    var viewFrame = self.view.bounds;
    let studyFrame = self.appInstance.studyController(self.view.window).view.bounds
    let y = location.y
    if (y<=0) {
      y = 0
    }
    if (y>=studyFrame.height-15) {
      y = studyFrame.height-15
    }
    let x = location.x
    
    if (self.custom) {
      // Application.sharedInstance().showHUD(self.custom, self.view.window, 2);
      self.customMode = "None"
      self.view.frame = {x:x,y:y,width:self.lastFrame.width,height:self.lastFrame.height}
      self.currentFrame  = self.view.frame

    }else{
      self.view.frame = {x:x,y:y,width:frame.width,height:frame.height}
      self.currentFrame  = self.view.frame

    }
    self.custom = false;
  },
  onResizeGesture:function (gesture) {
    self.custom = false;
    self.dynamic = false;
    let baseframe = gesture.view.frame
    let locationInView = gesture.locationInView(gesture.view)
    let frame = self.view.frame
    let width = locationInView.x+baseframe.x+baseframe.width*0.5
    let height = locationInView.y+baseframe.y+baseframe.height*0.5
    if (width <= 200) {
      width = 200
    }
    if (height <= 100) {
      height = 100
    }
    //  Application.sharedInstance().showHUD(`{x:${translation.x},y:${translation.y}}`, self.view.window, 2);
    //  self.view.frame = {x:frame.x,y:frame.y,width:frame.width+translationX,height:frame.height+translationY}
    self.view.frame = {x:frame.x,y:frame.y,width:width,height:height}
    self.currentFrame  = self.view.frame
  },
});
styleController.prototype.setButtonLayout = function (button,targetAction) {
    button.autoresizingMask = (1 << 0 | 1 << 3);
    button.setTitleColorForState(UIColor.whiteColor(),0);
    button.setTitleColorForState(this.highlightColor, 1);
    button.backgroundColor = UIColor.colorWithHexString("#9bb2d6").colorWithAlphaComponent(0.8);
    button.layer.cornerRadius = 10;
    button.layer.masksToBounds = true;
    if (targetAction) {
      button.addTargetActionForControlEvents(this, targetAction, 1 << 6);
    }
    this.view.addSubview(button);
}
styleController.prototype.setColorButtonLayout = function (button,targetAction,color) {
    button.autoresizingMask = (1 << 0 | 1 << 3);
    button.setTitleColorForState(UIColor.blackColor(),0);
    button.setTitleColorForState(this.highlightColor, 1);
    button.backgroundColor = UIColor.colorWithHexString(color).colorWithAlphaComponent(0.8);
    button.layer.cornerRadius = 10;
    button.layer.masksToBounds = true;
    if (targetAction) {
      button.addTargetActionForControlEvents(this, targetAction, 1 << 6);
    }
    this.view.addSubview(button);
}
styleController.prototype.autoAction = function (focusNote) {
  let colorIndex = focusNote.colorIndex
  let shouldSearch
  let shouldBigbang
  let shouldSnipaste
  let shouldCopy
  if (focusNote.excerptPic) {
    shouldSearch = [1,3].includes(this.searchPattern[colorIndex])
    shouldBigbang = [1,3].includes(this.bigbangPattern[colorIndex])
    shouldSnipaste = [1,3].includes(this.snipastePattern[colorIndex])
    shouldCopy = [1,3].includes(this.copyPattern[colorIndex])
  }else{
    shouldSearch = [1,2].includes(this.searchPattern[colorIndex])
    shouldBigbang = [1,2].includes(this.bigbangPattern[colorIndex])
    shouldSnipaste = [1,2].includes(this.snipastePattern[colorIndex])
    shouldCopy = [1,2].includes(this.copyPattern[colorIndex])
  }
  if (shouldSearch) {
    NSNotificationCenter.defaultCenter().postNotificationNameObjectUserInfo('searchInBrowser', this.appInstance.focusWindow, {text:focusNote.excerptText.trim()})
  }
  if (shouldBigbang) {
    NSNotificationCenter.defaultCenter().postNotificationNameObjectUserInfo('bigbangNote', this.appInstance.focusWindow, {noteid:focusNote.noteId})
    // this.appInstance.showHUD("shouldBigbang",this.view.window)
  }
  if (shouldSnipaste) {
    NSNotificationCenter.defaultCenter().postNotificationNameObjectUserInfo('snipasteNote', this.appInstance.focusWindow, {noteid:focusNote.noteId})
    // this.appInstance.showHUD("shouldSnipaste",this.view.window)
  }
  if (shouldCopy) {
    if (focusNote.excerptPic) {
      let imageData = Database.sharedInstance().getMediaByHash(focusNote.excerptPic.paint)
      UIPasteboard.generalPasteboard().setDataForPasteboardType(imageData,"public.png")
      // self.appInstance.showHUD('截图已复制到剪贴板',self.view.window,2)
    }else{
      UIPasteboard.generalPasteboard().string = focusNote.excerptText
    }
  }
}
function getSplitLine() {
    let studyFrame = Application.sharedInstance().studyController(this.window).view.bounds
    let readerFrame = Application.sharedInstance().studyController(this.window).readerController.view.frame
    let hidden = Application.sharedInstance().studyController(this.window).readerController.view.hidden//true代表脑图全屏
    let rightMode = Application.sharedInstance().studyController(this.window).rightMapMode
    let fullWindow = readerFrame.width == studyFrame.width
    if (hidden || fullWindow) {
      let splitLine = studyFrame.width*0.5
      return splitLine
    }
    if (rightMode) {
      let splitLine = readerFrame.x+readerFrame.width
      return splitLine
    }else{
      let splitLine = readerFrame.x
      return splitLine
    }
  }